-- Version: v11.1 11.1.0.14

library ieee;
use ieee.std_logic_1164.all;
library SmartFusion2;
use SmartFusion2.all;

entity Trigger_receiver_v1_7_OSC_0_OSC is

    port( XTL                : in    std_logic;
          RCOSC_25_50MHZ_CCC : out   std_logic;
          RCOSC_25_50MHZ_O2F : out   std_logic;
          RCOSC_1MHZ_CCC     : out   std_logic;
          RCOSC_1MHZ_O2F     : out   std_logic;
          XTLOSC_CCC         : out   std_logic;
          XTLOSC_O2F         : out   std_logic
        );

end Trigger_receiver_v1_7_OSC_0_OSC;

architecture DEF_ARCH of Trigger_receiver_v1_7_OSC_0_OSC is 

  component XTLOSC
    generic (MODE:std_logic_vector := x"3"; 
        FREQUENCY:real := 20.0);

    port( XTL    : in    std_logic := 'U';
          CLKOUT : out   std_logic
        );
  end component;


begin 


    I_XTLOSC : XTLOSC
      generic map(MODE => x"3", FREQUENCY => 12.0)

      port map(XTL => XTL, CLKOUT => XTLOSC_CCC);
    

end DEF_ARCH; 
