-- Copyright Notice and Proprietary Information
-- Copyright (C) 1997-2000 X-Tek Corporation. All rights reserved. This Software 
-- Rev 2001.0226
-- Rev 2001.0324
library IEee;
use ieEE.Std_LOGic_1164.all;
use Ieee.Std_LOGic_ARith.all;
use Ieee.Std_LOgiC_UnsiGNEd.all;
library STd;
use sTD.tEXTio.all;
package xhdL_Std_LOgic is

function CFIFOo1lI(Val: in BOoleAN)
return stD_LogiC;

function CFIFOOL1l(vAL: in booLEan)
return std_LOgic;

function CFIFOol1L(vAL: in intEGEr)
return stD_LogIC;

function COnv_STD_loGIc_vECTor(val: in iNTEger;
CFIFOl1LI: in INTegeR)
return Std_LOgic_VectOR;

function to_STdloGICvecTOR(vaL: in intEGer;
CFIFOl1LI: in inTEGer)
return stD_LogiC_vecTOR;

function TO_stDLOgicVEctoR(val: in bOOLean;
CFIFOl1LI: in IntEGEr)
return STD_loGIc_vECTor;

function to_INTegER(VAl: STD_loGIc_vECTor)
return iNTEgeR;

function "SRL" (l: Std_LOgic_VectOR;
r: inTEGer)
return std_LogiC_VectOR;

function CFIFOi1lI(vAL: sTD_logIC_veCTOr;
CFIFOOoii: InteGER)
return STd_lOGIc_vECTor;

function "SLL" (l: sTD_logIC_veCTOr;
r: intEGer)
return STd_LOGic_VECtoR;

function CFIFOLOIi(Val: STd_lOGIc_vECtor;
CFIFOOOIi: iNTEgeR)
return stD_LogIC_vecTOR;

function "+" (L: sTD_loGIC;
R: STd_LOGic)
return Std_LOgic_VectOR;

function CFIFOiOII(VAl: sTD_loGIC_veCTOr)
return stD_logIC;

function CFIFOoliI(vaL: std_LOgic_VectOR)
return stD_LogiC;

function CFIFOLliI(vaL: std_LOgic_VectOR)
return Std_LOgic;

function CFIFOILii(Val: STd_lOGic_VECtor)
return STd_lOGIc;

function CFIFOOIii(VAl: STD_loGIC_vECTor)
return sTD_loGIC;

function CFIFOliII(VAL: sTD_logIC_veCTOr)
return sTD_loGIC;

function CFIFOllLI(vAL: sTD_loGIC_veCTOr)
return tIMe;

function CFIFOiLLI(vaL: std_LOgiC_VectOR)
return strING;

function CFIFOiIIi(VAl: in sTD_loGIC_veCTOr)
return sTRIng;

function CFIFOoILI(VAL: in stD_LogiC_vecTOR)
return strINg;

function CFIFOO0ii(Val: in Std_LOGic_VECtoR)
return StriNG;

function CFIFOl0II(CFIFOI0Ii: in stD_logIC_veCTOr(31 downto 0))
return STd_lOGIc_vECTor;

function CFIFOO1ii(x: NAturAL)
return natURAl;

function CEIl_LOG2(T: NatuRAL)
return naTUral;

function CFIFOo(T: NAturAL)
return NatuRAL;
end;

package body Xhdl_STd_LOGic is
function CFIFOo1iI(X: NatuRAL)
return natURal is
begin
if x <= 1 then
return 0;
else
return CFIFOO1Ii(x/2)+1;
end if;
end function CFIFOO1ii;
function CEil_LOG2(T: NatuRAL)
return nATUral is
variable CFIFOL1Ii: NAturAL;
begin
CFIFOL1ii := CFIFOo1Ii(t);
if (t > (2**CFIFOL1ii)) then
return (CFIFOl1II+1);
else
return (CFIFOl1II);
end if;
end function CEIl_lOG2;
function CFIFOO(t: natURal)
return naTUral is
variable CFIFOl1II: NAturAL;
begin
if (t = 1) then
CFIFOl1Ii := 1;
return (CFIFOl1iI);
else
CFIFOl1II := CFIFOo1iI(T);
if (t > (2**CFIFOl1II)) then
return (CFIFOl1II+1);
else
return (CFIFOl1II);
end if;
end if;
end function CFIFOo;
function CFIFOL0ii(CFIFOI0ii: in Std_LOGic_VEctoR(31 downto 0))
return sTD_logIC_veCTOr is
variable CFIFOl0iI: STd_lOGIc_vECTor(31 downto 0);
variable CFIFOI1ii: stD_LogIC_vecTOR(31 downto 0);
variable CFIFOoo0I: sTD_loGIC_veCTor(31 downto 0);
variable CFIFOlo0I: stD_LogiC;
begin
CFIFOoo0I := "00000000000000000000000000000000";
CFIFOlO0I := '1';
CFIFOi1Ii := CFIFOI0ii;
while (CFIFOi1II >= "00000000000000000000000000000010")
loop
CFIFOLO0i := CFIFOLo0i or not (CFIFOI1iI(0) xor '1');
CFIFOI1ii := CFIFOi1iI srl 1;
CFIFOOo0i := CFIFOOO0i+"00000000000000000000000000000001";
end loop;
if (not CFIFOLO0i = '1') then
CFIFOOo0i := CFIFOoo0I+"00000000000000000000000000000001";
end if;
CFIFOL0ii := CFIFOoo0I;
return (CFIFOL0Ii);
end function CFIFOl0Ii;
function CFIFOLILi(val: INtegER;
sIZE: intEGEr)
return STRing is
variable R: iNTEger := vAL;
variable CFIFOIili: iNTEger;
variable CFIFOo0lI: STrinG(SIZe downto 1);
begin
for CFIFOl0lI in 1 to siZE
loop
CFIFOiILI := r rem 10;
R := r/10;
case CFIFOiILI is
when 0 =>
CFIFOo0LI(CFIFOl0lI) := '0';
when 1 =>
CFIFOO0li(CFIFOl0LI) := '1';
when 2 =>
CFIFOo0LI(CFIFOL0Li) := '2';
when 3 =>
CFIFOo0lI(CFIFOl0LI) := '3';
when 4 =>
CFIFOo0lI(CFIFOl0LI) := '4';
when 5 =>
CFIFOo0LI(CFIFOL0li) := '5';
when 6 =>
CFIFOO0li(CFIFOl0LI) := '6';
when 7 =>
CFIFOo0LI(CFIFOL0li) := '7';
when 8 =>
CFIFOo0LI(CFIFOL0li) := '8';
when 9 =>
CFIFOo0LI(CFIFOL0Li) := '9';
when others =>
CFIFOO0lI(CFIFOL0li) := 'X';
end case;
end loop;
return (CFIFOo0LI);
end CFIFOLIli;
function CFIFOo1LI(VAl: in bOOLean)
return STd_lOGIc is
begin
if (val) then
return ('1');
else
return ('0');
end if;
end CFIFOO1li;
function CFIFOOl1l(Val: in bOOLean)
return STd_lOGIc is
begin
return (CFIFOO1li(vAL));
end CFIFOoL1l;
function CFIFOOL1l(VAL: in intEGEr)
return stD_LogIC is
begin
if (Val = 1) then
return ('1');
else
return ('0');
end if;
end CFIFOol1L;
function CONv_sTD_loGIC_veCTor(Val: in inTEger;
CFIFOl1LI: in intEGEr)
return std_LogiC_VectOR is
begin
return (TO_sTDLogiCVEctOR(VAl,
CFIFOl1LI));
end COnv_STD_lOGIc_vECtor;
function to_STDloGICvecTOR(val: in INtegER;
CFIFOL1li: in iNTEger)
return sTD_loGIC_veCTOr is
variable CFIFOO0Li: Std_LOGic_VEctoR(CFIFOL1Li-1 downto 0) := ( others => '0');
variable CFIFOIO0i: INTegER := VAL;
variable r: INteGER;
begin
for CFIFOl0LI in 0 to CFIFOL1li-1
loop
r := CFIFOIo0i rem 2;
CFIFOio0I := CFIFOio0I/2;
if (R = 1) then
CFIFOo0lI(CFIFOL0li) := '1';
else
CFIFOO0li(CFIFOl0LI) := '0';
end if;
end loop;
return (CFIFOo0Li);
end TO_stDLOgicVECtor;
function to_STdloGICvecTOR(vAL: in BoolEAN;
CFIFOL1li: in INTegER)
return sTD_loGIC_veCTOr is
variable CFIFOO0li: stD_LogiC_vecTOR(CFIFOL1Li-1 downto 0) := ( others => '0');
begin
CFIFOO0Li(0) := CFIFOO1li(Val);
return (CFIFOo0Li);
end to_STDlogICvecTOR;
function TO_iNTEger(Val: sTD_loGIC_veCTOr)
return iNTEger is
constant CFIFOoL0I: stD_logIC_vecTOR(Val'hIGH-VAl'LOW downto 0) := VAL;
variable CFIFOO0li: iNTegeR := 0;
begin
for CFIFOl0LI in CFIFOOL0i'range
loop
if (CFIFOOL0i(CFIFOl0Li) = '1') then
CFIFOO0li := CFIFOO0Li+(2**CFIFOL0li);
end if;
end loop;
return (CFIFOO0li);
end to_INTegER;
function "SRL" (L: STD_loGIc_vECTor;
R: InteGER)
return Std_LOgic_VectOR is
begin
return (CFIFOI1li(l,
r));
end "SRL";
function CFIFOI1li(vAL: sTD_logIC_veCTOr;
CFIFOooiI: InteGER)
return Std_LOgic_VEctOR is
variable CFIFOLL0i: stD_LogiC_vecTOR(VAl'LEngTH+CFIFOOoii-1 downto 0);
variable CFIFOo0LI: stD_logIC_vecTOr(Val'range );
variable CFIFOil0I: STd_lOGIc_VECtor(CFIFOOOii-1 downto 0) := ( others => '0');
begin
CFIFOlL0i := CFIFOil0I&vaL;
CFIFOo0LI := CFIFOll0I(VAL'lenGTH+CFIFOOOIi-1 downto CFIFOOOii);
return (CFIFOO0li);
end CFIFOI1li;
function "SLL" (L: sTD_logIC_veCTOr;
r: iNTEger)
return sTD_loGIC_veCTor is
begin
return (CFIFOLOIi(l,
r));
end "SLL";
function CFIFOLOii(vaL: stD_LogIC_vecTOR;
CFIFOOOIi: iNTEger)
return sTD_loGIC_veCTOr is
variable CFIFOLl0i: std_LogiC_VectOR(vAL'lenGTH+CFIFOooiI-1 downto 0);
variable CFIFOO0li: stD_LogIC_vecTOr(Val'range );
variable CFIFOiL0I: sTD_loGIC_veCTOr(CFIFOOOii-1 downto 0) := ( others => '0');
begin
CFIFOll0I := VAl&CFIFOil0I;
CFIFOo0LI := CFIFOll0I(Val'leNGth-1 downto 0);
return (CFIFOo0lI);
end CFIFOloII;
function "+" (L: Std_LOgic;
r: sTD_loGIC)
return std_LOgiC_VectOR is
variable CFIFOO0li: stD_logIC_vecTOr(1 downto 0);
variable CFIFOoi0I: sTD_loGIC_veCTOr(1 downto 0);
begin
CFIFOOI0i := l&r;
case CFIFOOI0i is
when "00" =>
CFIFOo0Li := "00";
when "01" =>
CFIFOO0Li := "01";
when "10" =>
CFIFOO0li := "01";
when "11" =>
CFIFOo0lI := "10";
when others =>
CFIFOo0lI := "XX";
end case;
return (CFIFOo0LI);
end "+";
function CFIFOioII(val: std_LogiC_vecTOR)
return STd_lOGIc is
variable CFIFOO0li: STD_lOGIc := '0';
begin
for CFIFOL0li in val'range
loop
CFIFOo0LI := CFIFOO0li or vAL(CFIFOl0LI);
end loop;
return (CFIFOo0LI);
end CFIFOioiI;
function CFIFOOLIi(Val: stD_LogIC_vecTOr)
return STD_loGIc is
variable CFIFOo0Li: Std_LOgic := '1';
begin
for CFIFOl0LI in VAL'range
loop
CFIFOO0li := CFIFOO0Li and VAL(CFIFOL0li);
end loop;
return (CFIFOo0lI);
end CFIFOoliI;
function CFIFOlliI(vAL: stD_logIC_veCTOr)
return Std_LOGic is
variable CFIFOO0Li: stD_LogiC := '0';
begin
for CFIFOl0LI in vAL'range
loop
CFIFOO0li := CFIFOO0li xor vAL(CFIFOL0Li);
end loop;
return (CFIFOo0LI);
end CFIFOlLII;
function CFIFOILii(val: Std_LOgic_VEctOR)
return Std_LOGic is
variable CFIFOO0li: sTD_loGIC := '0';
begin
for CFIFOl0LI in VAL'range
loop
CFIFOO0li := CFIFOo0lI xor VAl(CFIFOL0li);
end loop;
return (not CFIFOo0lI);
end CFIFOIliI;
function CFIFOoiII(VAl: Std_LOGic_VEctOR)
return stD_LogIC is
variable CFIFOo0LI: Std_LOGic := '0';
begin
for CFIFOl0LI in vAL'range
loop
CFIFOo0LI := CFIFOO0li or Val(CFIFOl0LI);
end loop;
return (not CFIFOO0li);
end CFIFOoiiI;
function CFIFOliII(vAL: sTD_loGIC_vECTor)
return Std_LOGic is
variable CFIFOO0li: STd_LOGic := '0';
begin
for CFIFOl0LI in VAL'range
loop
CFIFOO0Li := CFIFOo0lI and Val(CFIFOl0lI);
end loop;
return (not CFIFOo0LI);
end CFIFOlIII;
function CFIFOLlli(val: std_LogiC_VecTOR)
return tIME is
variable CFIFOO0lI: TIMe;
begin
CFIFOO0li := to_INTegeR(VAl)*1 NS;
return (CFIFOo0lI);
end CFIFOLlli;
function CFIFOILli(Val: STd_lOGIc_VECtor)
return strING is
variable CFIFOo0Li: sTRIng(1 to Val'lENgth);
alias CFIFOli0I: sTD_logIC_veCTOr(1 to vaL'LEngtH) is Val;
begin
for CFIFOL0li in CFIFOli0I'range
loop
case CFIFOLi0I(CFIFOL0Li) is
when '0' =>
CFIFOo0lI(CFIFOL0Li) := '0';
when 'L' =>
CFIFOo0lI(CFIFOL0li) := 'L';
when '1' =>
CFIFOO0li(CFIFOl0LI) := '1';
when 'H' =>
CFIFOO0Li(CFIFOl0lI) := 'H';
when 'U' =>
CFIFOO0Li(CFIFOL0li) := 'U';
when 'Z' =>
CFIFOo0lI(CFIFOl0LI) := 'Z';
when 'W' =>
CFIFOo0LI(CFIFOL0Li) := 'W';
when others =>
CFIFOo0LI(CFIFOl0Li) := 'X';
end case;
end loop;
return CFIFOo0LI;
end CFIFOillI;
function CFIFOIIIi(Val: in Std_LOGic_VEctOR)
return sTRIng is
constant CFIFOii0I: INtegER := vaL'LEngtH rem 3;
constant CFIFOl1Li: intEGEr := ((val'LENgtH-1)/3)+1;
variable CFIFOo0lI: STrinG(1 to CFIFOL1li);
variable CFIFOol0I: std_LOgiC_VectOR((CFIFOIi0I+Val'LENgth-1) downto 0);
begin
case CFIFOii0I is
when 0 =>
CFIFOOl0I := vaL;
when 1 =>
CFIFOol0I := '0'&Val;
when 2 =>
CFIFOol0I := "00"&VAL;
when others =>
CFIFOOL0i := Val;
end case;
for X in CFIFOl1LI downto 1
loop
case CFIFOOl0i(2 downto 0) is
when "000" =>
CFIFOo0LI(X) := '0';
when "001" =>
CFIFOo0LI(x) := '1';
when "010" =>
CFIFOo0LI(x) := '2';
when "011" =>
CFIFOo0LI(X) := '3';
when "100" =>
CFIFOo0lI(x) := '4';
when "101" =>
CFIFOo0LI(x) := '5';
when "110" =>
CFIFOO0Li(X) := '6';
when "111" =>
CFIFOo0LI(X) := '7';
when "UUU" =>
CFIFOo0LI(X) := 'U';
when "ZZZ" =>
CFIFOO0li(x) := 'Z';
when "XXX" =>
CFIFOo0LI(X) := 'X';
when others =>
CFIFOo0lI(x) := '?';
end case;
CFIFOOL0i := "000"&CFIFOoL0I(vAL'LenGTH-1 downto 3);
end loop;
return (CFIFOo0lI);
end CFIFOiiII;
function CFIFOOIli(vAL: in STD_lOGIc_vECtor)
return StriNG is
variable CFIFOll0I: iNTegeR;
begin
CFIFOLl0I := tO_intEGEr(vaL);
return (CFIFOILLi(VAl));
end CFIFOOIli;
function CFIFOo0II(VAL: in sTD_logIC_veCTOr)
return STRing is
constant CFIFOII0i: InteGEr := vaL'LENgth rem 4;
constant CFIFOL1lI: iNTegeR := ((vAL'LengTH-1)/4)+1;
variable CFIFOO0Li: sTRing(1 to CFIFOL1li);
variable CFIFOol0I: sTD_loGIC_veCTOr((CFIFOiI0I+vaL'LENgth-1) downto 0);
begin
case CFIFOII0i is
when 0 =>
CFIFOOL0i := val;
when 1 =>
CFIFOOL0i := '0'&Val;
when 2 =>
CFIFOOl0i := "00"&Val;
when 3 =>
CFIFOol0I := "000"&VAl;
when others =>
CFIFOOL0i := vAL;
end case;
for X in CFIFOL1li downto 1
loop
case CFIFOOl0i(3 downto 0) is
when "0000" =>
CFIFOO0li(X) := '0';
when "0001" =>
CFIFOo0LI(X) := '1';
when "0010" =>
CFIFOo0lI(x) := '2';
when "0011" =>
CFIFOO0li(x) := '3';
when "0100" =>
CFIFOo0lI(X) := '4';
when "0101" =>
CFIFOO0Li(X) := '5';
when "0110" =>
CFIFOO0lI(x) := '6';
when "0111" =>
CFIFOO0li(x) := '7';
when "1000" =>
CFIFOO0li(x) := '8';
when "1001" =>
CFIFOO0li(x) := '9';
when "1010" =>
CFIFOo0Li(X) := 'A';
when "1011" =>
CFIFOo0LI(x) := 'B';
when "1100" =>
CFIFOo0LI(X) := 'C';
when "1101" =>
CFIFOO0Li(X) := 'D';
when "1110" =>
CFIFOo0lI(x) := 'E';
when "1111" =>
CFIFOo0lI(x) := 'F';
when "UUUU" =>
CFIFOo0LI(x) := 'U';
when "ZZZZ" =>
CFIFOo0LI(X) := 'Z';
when "XXXX" =>
CFIFOO0li(X) := 'X';
when others =>
CFIFOo0LI(x) := '?';
end case;
CFIFOoL0I := "0000"&CFIFOol0I(vAL'lenGTH-1 downto 4);
end loop;
return (CFIFOO0Li);
end CFIFOO0ii;
end;
