--  Copyright 2011 Actel Corporation.  All rights reserved.
-- ANY USE OR REDISTRIBUTION IN PART OR IN WHOLE MUST BE HANDLED IN
-- ACCORDANCE WITH THE ACTEL LICENSE AGREEMENT AND MUST BE APPROVED
-- Revision Information:
-- SVN Revision Information:
-- SVN $Revision: 4805 $
library ieeE;
use ieEE.Std_logIC_1164.all;
use iEEE.STd_lOGIc_UNSignED.all;
use ieEE.Std_LOgic_Misc.all;
use Work.xhDL_stD_LogiC.all;
use WORk.XHdl_MIsc.all;
entity CFIFOlIL is
generic (CFIFOil: intEGEr := 18;
CFIFOoi: InteGER := 10;
CFIFOLI: InteGER := 1024;
CFIFOiI: inTEGer := 18;
CFIFOO0: iNTEgeR := 10;
CFIFOL0: IntEGEr := 1024;
CFIFOi0: iNTEgeR := 1;
CFIFOl1: InteGER := 1;
CFIFOi1: iNTEger := 1;
CFIFOooL: INtegER := 1;
CFIFOLol: iNTEger := 1;
CFIFOiOL: IntEGEr := 1;
CFIFOolL: INtegER := 1020;
CFIFOLLL: intEGEr := 4;
esTOp: inTEGer := 1;
FStop: INtegER := 1;
CFIFOilL: InteGER := 1;
reaD_DvaLID: inTEger := 1;
wrITE_aCK: InteGEr := 1;
OVErflOW_en: INtegER := 1;
undERfloW_En: iNTegeR := 1;
WrcnT_en: iNTEger := 1;
RDcnT_En: inTEger := 1); port (Clk: in STD_loGIc;
reSET: in Std_LOGic;
WE: in sTD_logIC;
re: in STd_lOGIc;
FulL: out STd_lOGic;
AFUll: out Std_LOgic;
wrcNT: out sTD_logIC_veCTOr(CFIFOoi downto 0);
EmptY: out stD_logIC;
aEMpty: out std_LogiC;
RDcnT: out STd_lOGIc_vECtor(CFIFOO0 downto 0);
UNderFLOw: out Std_LOgic;
ovERFlow: out stD_logIC;
dvLD: out sTD_loGIC;
waCK: out sTD_logIC;
MemwADDr: out STd_lOGIc_VECtor(CFIFOo(CFIFOLI)-1 downto 0);
MEMwe: out Std_LOGic;
meMRAddR: out sTD_loGIC_veCTor(CFIFOO(CFIFOL0)-1 downto 0);
mEMre: out STd_LOGic);
end entity CFIFOLil;

architecture CFIFOL of CFIFOLil is

signal CFIFOoiOL: STd_lOGIc;

signal CFIFOL0il: STD_loGIC;

signal CFIFOliOL: STd_lOGic;

signal CFIFOiIOL: std_LOgiC;

signal CFIFOO0ol: stD_logIC;

signal CFIFOl0OL: sTD_logIC_veCTOr(CFIFOo(CFIFOLI)-1 downto 0);

signal CFIFOI0ol: Std_LOGic_VEctoR(CFIFOo(CFIFOl0)-1 downto 0);

signal CFIFOO1oL: STd_LOGic;

signal CFIFOl1OL: STD_loGIC;

signal CFIFOi1OL: Std_LOGic;

signal CFIFOoOLl: std_LOgiC;

signal CFIFOLOll: sTD_loGIC;

signal CFIFOlOOi: stD_LogIC_veCTOr(CFIFOo0 downto 0);

signal CFIFOO1ll: Std_LOgic_VectOR(CFIFOOi downto 0);

signal CFIFOI1lL: stD_LogiC_vecTOR(CFIFOo0 downto 0);

signal CFIFOLOil: sTD_loGIC;

signal CFIFOioiL: STd_lOGIc;

signal CFIFOLLil: sTD_logIC;

signal CFIFOoliL: std_LogiC;

signal CFIFOOO1l: stD_LogIC;

signal CFIFOl10L: Std_LOGic;

signal CFIFOi10L: STd_LOGic;

signal CFIFOO10L: STd_lOGIc;

signal CFIFOo11L: STd_LOGic;

signal CFIFOo00L: Std_LOgic;

signal CFIFOOiil: STD_loGIc;

signal CFIFOLiiL: sTD_loGIC_veCTOr(CFIFOo0 downto 0);

signal CFIFOiIIl: sTD_loGIC_veCTor(CFIFOo0 downto 0);

signal CFIFOiOI: INteGER;

signal CFIFOolI: iNTegeR;

signal CFIFOLli: sTD_loGIC;

signal CFIFOili: sTD_loGIC;

signal CFIFOoii: sTD_loGIC;

signal CFIFOlii: STD_loGIc;

signal CFIFOo0IL: Std_LOGic;

signal CFIFOI0Il: std_LogiC;

signal CFIFOO1il: Std_LOgic_VectOR(CFIFOOi downto 0);

signal CFIFOI1i: std_LOgiC;

signal CFIFOi1Il: stD_logIC;

signal CFIFOOO0l: Std_LOGic_VEctoR(CFIFOO0 downto 0);

signal CFIFOLo0l: STd_lOGIc;

signal CFIFOIO0l: STD_lOGIc;

signal CFIFOoL0L: std_LogiC;

signal CFIFOll0L: STd_lOGic;

signal CFIFOiL0L: std_LogiC;

signal CFIFOoi0L: stD_LogiC_vecTOR(CFIFOo(CFIFOLI)-1 downto 0);

signal CFIFOlI0L: std_LogiC;

signal CFIFOII0l: Std_LOgic_VectOR(CFIFOO(CFIFOL0)-1 downto 0);

signal CFIFOo00: STD_lOGIc;

begin
Full <= CFIFOo0IL;
afuLL <= CFIFOI0il;
wRCNt <= CFIFOO1il;
empTY <= CFIFOi1I;
aeMPty <= CFIFOi1IL;
rDCNt <= CFIFOoo0L;
UNDerFLOw <= CFIFOlO0l;
ovERFlow <= CFIFOio0L;
dVLD <= CFIFOOl0L;
WacK <= CFIFOIl0l;
memWADdr <= CFIFOoi0L;
meMWe <= CFIFOLI0l;
MemrADdr <= CFIFOIi0l;
memRE <= CFIFOo00;
CFIFOo0IL <= CFIFOOiol;
CFIFOi0IL <= CFIFOliOL;
CFIFOI1i <= CFIFOIIol;
CFIFOI1il <= CFIFOO0ol;
CFIFOLo0L <= CFIFOI1oL;
CFIFOiL0L <= CFIFOOOLl;
CFIFOio0L <= CFIFOlOLL;
CFIFOOI0l <= CFIFOL0ol;
CFIFOiI0L <= CFIFOI0Ol;
CFIFOLi0l <= CFIFOI10l;
CFIFOO00 <= CFIFOo10L;
CFIFOLIil <= CFIFOLOOi when wrcNT_en /= 0 else
( others => '0');
CFIFOO1il <= CFIFOlIIL;
CFIFOIiiL <= CFIFOLOoi when rDCNt_eN /= 0 else
( others => '0');
CFIFOoo0L <= CFIFOiiIL;
CFIFOiOI <= (CFIFOolL-2) when CFIFOLol /= 0 else
(CFIFOLI-1);
CFIFOo1LL <= Conv_Std_LOGic_VEctOR(CFIFOioI,
CFIFOoI+1);
CFIFOOli <= CFIFOllL when CFIFOioL /= 0 else
0;
CFIFOi1LL <= coNV_stD_LogiC_vecTOr(CFIFOOLi,
CFIFOO0+1);
CFIFOllI <= cLK when CFIFOI0 /= 0 else
not clk;
CFIFOo11L <= CFIFOlLI;
CFIFOILi <= not ResET when CFIFOl1 /= 0 else
RESet;
CFIFOo00L <= CFIFOiLI;
CFIFOoII <= (not WE) when CFIFOi1 /= 0 else
(we);
CFIFOOO1l <= CFIFOOii;
CFIFOLii <= (not rE) when CFIFOool /= 0 else
(Re);
CFIFOl10L <= CFIFOlII;
CFIFOi10L <= CFIFOOo1l and not CFIFOOioL;
CFIFOo10L <= CFIFOl10L and not CFIFOiiOL;
CFIFOLl0L <= CFIFOo1OL when (CFIFOIll = 1) else
CFIFOO10l;
CFIFOol0L <= CFIFOl1oL when (CFIFOILl = 2) else
CFIFOLl0l;
process (CFIFOo00L,CFIFOo11L)
begin
if (not CFIFOo00L = '1') then
CFIFOlooI <= ( others => '0');
elsif (CFIFOo11L'EvenT and CFIFOO11l = '1') then
if ((CFIFOI10l xor CFIFOO10l) = '1') then
if (CFIFOI10l = '1') then
CFIFOloOI <= CFIFOlooI+'1';
else
if (CFIFOo10L = '1') then
CFIFOlooI <= CFIFOLooI-'1';
end if;
end if;
end if;
end if;
end process;
CFIFOIOil <= ((CFIFOol1L(CFIFOLOoi >= (CFIFOO1ll)) and CFIFOI10L) and not CFIFOo10L) or ((CFIFOoL1L(CFIFOLooi > CFIFOo1LL) and not CFIFOi10L) and CFIFOO10l);
CFIFOOLil <= ((CFIFOOL1l(CFIFOloOI <= (CFIFOI1Ll+'1')) and not CFIFOi10L) and CFIFOO10l) or ((CFIFOOL1l(CFIFOlOOI < CFIFOi1LL) and CFIFOi10L) and not CFIFOo10L);
CFIFOloiL <= (CFIFOoL1L(CFIFOLOOi = ConV_Std_LOgic_VEctOR((CFIFOLI-2),
CFIFOOi+1)) and CFIFOI10l) and not CFIFOo10L;
CFIFOLLil <= (CFIFOOL1l(to_InteGER(CFIFOlooI) = 1) and not CFIFOI10l) and CFIFOO10l;
process (CFIFOO11l,CFIFOO00l)
begin
if (not CFIFOo00L = '1') then
CFIFOl1OL <= '0';
elsif (CFIFOo11L'evENT and CFIFOO11L = '1') then
CFIFOL1ol <= CFIFOO1Ol;
end if;
end process;
process (CFIFOO11l,CFIFOO00l)
begin
if (not CFIFOO00l = '1') then
CFIFOL0Il <= '0';
elsif (CFIFOO11l'eveNT and CFIFOo11L = '1') then
CFIFOL0il <= CFIFOOIol;
end if;
end process;
process (CFIFOO11l,CFIFOO00l)
begin
if (not CFIFOo00L = '1') then
CFIFOIiol <= '1';
CFIFOo0oL <= '1';
CFIFOo1oL <= '0';
CFIFOi1oL <= '0';
elsif (CFIFOO11l'EVEnt and CFIFOo11L = '1') then
if ((CFIFOI10l xor CFIFOO10l) = '1') then
CFIFOiioL <= CFIFOLlil;
end if;
if ((CFIFOI10L xor CFIFOO10l) = '1') then
CFIFOo0oL <= CFIFOolIL;
end if;
if (CFIFOo10L = '1' and Read_DValID = 1) then
CFIFOO1ol <= '1';
else
CFIFOO1ol <= '0';
end if;
if ((CFIFOL10l = '1' and CFIFOIIOl = '1') and UNderFLOw_eN = 1) then
CFIFOi1OL <= '1';
else
CFIFOI1ol <= '0';
end if;
end if;
end process;
process (CFIFOO11l,CFIFOO00l)
begin
if (not CFIFOO00l = '1') then
CFIFOoioL <= '0';
CFIFOlIOL <= '0';
CFIFOoOLl <= '0';
CFIFOlOLL <= '0';
elsif (CFIFOo11L'eVENt and CFIFOo11L = '1') then
if ((CFIFOI10l xor CFIFOo10L) = '1') then
CFIFOoIOL <= CFIFOloIL;
end if;
if ((CFIFOI10l xor CFIFOo10L) = '1') then
CFIFOLiol <= CFIFOioIL;
end if;
if (CFIFOi10L = '1' and WRIte_ACk = 1) then
CFIFOoolL <= '1';
else
CFIFOoolL <= '0';
end if;
if ((CFIFOOO1l = '1' and CFIFOL0il = '1') and OverFLOw_EN = 1) then
CFIFOLOll <= '1';
else
CFIFOLoll <= '0';
end if;
end if;
end process;
process (CFIFOo11L,CFIFOo00l)
begin
if (not CFIFOO00l = '1') then
CFIFOl0Ol <= ( others => '0');
elsif (CFIFOo11L'evENt and CFIFOO11l = '1') then
if (CFIFOI10l = '1') then
CFIFOL0ol <= CFIFOL0Ol+'1';
end if;
end if;
end process;
process (CFIFOo11L,CFIFOo00l)
begin
if (not CFIFOo00L = '1') then
CFIFOI0Ol <= ( others => '0');
elsif (CFIFOo11L'eveNT and CFIFOO11l = '1') then
if (CFIFOO10l = '1') then
CFIFOI0ol <= CFIFOi0OL+'1';
end if;
end if;
end process;
end architecture CFIFOL;
