quietly set ACTELLIBNAME SmartFusion2
quietly set PROJECT_DIR "C:/Actelprj/To_be_handed_to_Taku_01_11-13"
source "${PROJECT_DIR}/simulation/CompileDssBfm.tcl";source "${PROJECT_DIR}/simulation/bfmtovec_compile.tcl";

if {[file exists presynth/_info]} {
   echo "INFO: Simulation library presynth already exists"
} else {
   vlib presynth
}
vmap presynth presynth
vmap SmartFusion2 "C:/Microsemi/Libero_v11.1/Designer/lib/modelsim/precompiled/vhdl/SmartFusion2"
if {[file exists COREAPB3_LIB/_info]} {
   echo "INFO: Simulation library COREAPB3_LIB already exists"
} else {
   vlib COREAPB3_LIB
}
vmap COREAPB3_LIB "COREAPB3_LIB"
if {[file exists COREFIFO_OBF_LIB/_info]} {
   echo "INFO: Simulation library COREFIFO_OBF_LIB already exists"
} else {
   vlib COREFIFO_OBF_LIB
}
vmap COREFIFO_OBF_LIB "COREFIFO_OBF_LIB"

vcom -93 -explicit  -work presynth "${PROJECT_DIR}/hdl/dcs_interface_pkg.vhd"
vcom -93 -explicit  -work presynth "${PROJECT_DIR}/hdl/apb_to_dcs.vhd"
vcom -93 -explicit  -work presynth "${PROJECT_DIR}/component/work/Trigger_receiver_v1_7/FCCC_0/Trigger_receiver_v1_7_FCCC_0_FCCC.vhd"
vcom -93 -explicit  -work presynth "${PROJECT_DIR}/component/work/Trigger_receiver_v1_7/OSC_0/Trigger_receiver_v1_7_OSC_0_OSC.vhd"
vcom -93 -explicit  -work presynth "${PROJECT_DIR}/hdl/mux_arbit.vhd"
vcom -93 -explicit  -work presynth "${PROJECT_DIR}/hdl/arbit.vhd"
vcom -93 -explicit  -work presynth "${PROJECT_DIR}/hdl/rcu_addr_set.vhd"
vcom -93 -explicit  -work presynth "${PROJECT_DIR}/hdl/addr_decoder.vhd"
vcom -93 -explicit  -work presynth "${PROJECT_DIR}/hdl/cmd_decoder.vhd"
vcom -93 -explicit  -work presynth "${PROJECT_DIR}/hdl/rcu_reg.vhd"
vcom -93 -explicit  -work presynth "${PROJECT_DIR}/hdl/cnt20.vhd"
vcom -93 -explicit  -work presynth "${PROJECT_DIR}/hdl/posdge_pulse.vhd"
vcom -93 -explicit  -work presynth "${PROJECT_DIR}/hdl/cnt12.vhd"
vcom -93 -explicit  -work presynth "${PROJECT_DIR}/hdl/abs_cnt.vhd"
vcom -93 -explicit  -work presynth "${PROJECT_DIR}/hdl/rcu_dec.vhd"
vcom -93 -explicit  -work presynth "${PROJECT_DIR}/hdl/trigger_receiver_pkg.vhd"
vcom -93 -explicit  -work presynth "${PROJECT_DIR}/hdl/rcu_com_release.vhd"
vcom -93 -explicit  -work presynth "${PROJECT_DIR}/hdl/serialb_com.vhd"
vcom -93 -explicit  -work presynth "${PROJECT_DIR}/hdl/hamming_decoder.vhd"
vcom -93 -explicit  -work presynth "${PROJECT_DIR}/hdl/broadcast_msg_decoder.vhd"
vcom -93 -explicit  -work presynth "${PROJECT_DIR}/hdl/addressed_msg_decoder.vhd"
vcom -93 -explicit  -work presynth "${PROJECT_DIR}/hdl/L1_line_decoder.vhd"
vcom -93 -explicit  -work presynth "${PROJECT_DIR}/hdl/sequence_validator.vhd"
vcom -93 -explicit  -work presynth "${PROJECT_DIR}/hdl/phase_check.vhd"
vcom -93 -explicit  -work COREFIFO_OBF_LIB "${PROJECT_DIR}/component/work/ms_event_fifo/ms_event_fifo_0/rtl/vhdl/core_obfuscated/XHDL_std_logic.vhd"
vcom -93 -explicit  -work COREFIFO_OBF_LIB "${PROJECT_DIR}/component/work/ms_event_fifo/ms_event_fifo_0/rtl/vhdl/core_obfuscated/XHDL_misc.vhd"
vcom -93 -explicit  -work COREFIFO_OBF_LIB "${PROJECT_DIR}/component/work/ms_event_fifo/ms_event_fifo_0/rtl/vhdl/core_obfuscated/fifocore_sync_scntr.vhd"
vcom -93 -explicit  -work COREFIFO_OBF_LIB "${PROJECT_DIR}/component/work/ms_event_fifo/ms_event_fifo_0/rtl/vhdl/core_obfuscated/fifocore_sync.vhd"
vcom -93 -explicit  -work COREFIFO_OBF_LIB "${PROJECT_DIR}/component/work/ms_event_fifo/ms_event_fifo_0/rtl/vhdl/core_obfuscated/ms_event_fifo_ms_event_fifo_0_USRAM_top.vhd"
vcom -93 -explicit  -work COREFIFO_OBF_LIB "${PROJECT_DIR}/component/work/ms_event_fifo/ms_event_fifo_0/rtl/vhdl/core_obfuscated/ms_event_fifo_ms_event_fifo_0_ram_wrapper.vhd"
vcom -93 -explicit  -work COREFIFO_OBF_LIB "${PROJECT_DIR}/component/work/ms_event_fifo/ms_event_fifo_0/rtl/vhdl/core_obfuscated/COREFIFO.vhd"
vcom -93 -explicit  -work presynth "${PROJECT_DIR}/component/work/ms_event_fifo/ms_event_fifo.vhd"
vcom -93 -explicit  -work presynth "${PROJECT_DIR}/hdl/fifo_wrapper.vhd"
vcom -93 -explicit  -work presynth "${PROJECT_DIR}/hdl/counters.vhd"
vcom -93 -explicit  -work presynth "${PROJECT_DIR}/hdl/trigger_receiver.vhd"
vcom -93 -explicit  -work presynth "${PROJECT_DIR}/component/work/Trigger_receiver_v1_7_MSS/Trigger_receiver_v1_7_MSS.vhd"
vcom -93 -explicit  -work COREAPB3_LIB "${PROJECT_DIR}/component/Actel/DirectCore/CoreAPB3/4.0.100/rtl/vhdl/core_obfuscated/coreapb3_muxptob3.vhd"
vcom -93 -explicit  -work COREAPB3_LIB "${PROJECT_DIR}/component/Actel/DirectCore/CoreAPB3/4.0.100/rtl/vhdl/core_obfuscated/coreapb3_iaddr_reg.vhd"
vcom -93 -explicit  -work COREAPB3_LIB "${PROJECT_DIR}/component/Actel/DirectCore/CoreAPB3/4.0.100/rtl/vhdl/core_obfuscated/coreapb3.vhd"
vcom -93 -explicit  -work COREAPB3_LIB "${PROJECT_DIR}/component/Actel/DirectCore/CoreAPB3/4.0.100/rtl/vhdl/core_obfuscated/components.vhd"
vcom -93 -explicit  -work presynth "${PROJECT_DIR}/component/work/Trigger_receiver_v1_7/Trigger_receiver_v1_7.vhd"
vcom -93 -explicit  -work COREFIFO_OBF_LIB "${PROJECT_DIR}/component/work/ms_event_fifo/ms_event_fifo_0/rtl/vhdl/core_obfuscated/doubleSync.vhd"
vcom -93 -explicit  -work COREFIFO_OBF_LIB "${PROJECT_DIR}/component/work/ms_event_fifo/ms_event_fifo_0/rtl/vhdl/core_obfuscated/grayToBinConv.vhd"
vcom -93 -explicit  -work presynth "${PROJECT_DIR}/component/work/Trigger_receiver_v1_7/testbench.vhd"

vsim -L SmartFusion2 -L presynth -L COREAPB3_LIB -L COREFIFO_OBF_LIB  -t 1fs presynth.testbench
add wave /testbench/*
run -all
